/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumAnatomicSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_VesselDescriptors;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_VesselDescriptors;


/**
 * This class represents VesselDescriptors - CID3712
 */
public class VesselDescriptors_CID3712  
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;
	
	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	
	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;		
	/**
	 * Instantiates a new VesselDescriptors_CID3712 Template 
	 */
	public VesselDescriptors_CID3712()
	{
		
	}
	
	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumVesselDescriptors Object of EnumCM_VesselDescriptors represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_VesselDescriptors enumVesselDescriptors)
	{
		switch(enumVesselDescriptors)
		{
		case ULCERATED: this.strCodeValue =EnumCV_VesselDescriptors.ULCERATED_R_00389.getValue(); break;
		case RESTENOTIC: this.strCodeValue =EnumCV_VesselDescriptors.RESTENOTIC_R_0036B.getValue(); break;
		case BIFURCATION: this.strCodeValue =EnumCV_VesselDescriptors.BIFURCATION_R_002E2.getValue(); break;
		case CULPRIT: this.strCodeValue =EnumCV_VesselDescriptors.CULPRIT_R_002EF.getValue(); break;
		case ANEURYSMAL: this.strCodeValue =EnumCV_VesselDescriptors.ANEURYSMAL_R_002CE.getValue(); break;
		case DIFFUSE_DISEASE: this.strCodeValue =EnumCV_VesselDescriptors.DIFFUSE_DISEASE_R_002FC.getValue(); break;
		case LUMINAL_IRREGULARITIES: this.strCodeValue =EnumCV_VesselDescriptors.LUMINAL_IRREGULARITIES_R_00314.getValue(); break;
		case MUSCLE_BRIDGE: this.strCodeValue =EnumCV_VesselDescriptors.MUSCLE_BRIDGE_R_411C5.getValue(); break;
		case STENOTIC: this.strCodeValue =EnumCV_VesselDescriptors.STENOTIC_R_10050.getValue(); break;
		case ECTATIC: this.strCodeValue =EnumCV_VesselDescriptors.ECTATIC_R_10051.getValue(); break;
		case CALCIFIED: this.strCodeValue =EnumCV_VesselDescriptors.CALCIFIED_G_A264.getValue(); break;
		case THROMBUS: this.strCodeValue =EnumCV_VesselDescriptors.THROMBUS_M_35100.getValue(); break;
		case TORTUOUS: this.strCodeValue =EnumCV_VesselDescriptors.TORTUOUS_R_10048.getValue(); break;
		case STENTED: this.strCodeValue =EnumCV_VesselDescriptors.STENTED_R_10049.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumVesselDescriptors Object of EnumCM_VesselDescriptors represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_VesselDescriptors enumVesselDescriptors)
	{
		switch(enumVesselDescriptors)
		{
		case ULCERATED : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.ULCERATED.getSNOMEDCTID(); break;
		case RESTENOTIC : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.RESTENOTIC.getSNOMEDCTID(); break;
		case BIFURCATION : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.BIFURCATION.getSNOMEDCTID(); break;
		case CULPRIT : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.CULPRIT.getSNOMEDCTID(); break;
		case ANEURYSMAL : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.ANEURYSMAL.getSNOMEDCTID(); break;
		case DIFFUSE_DISEASE : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.DIFFUSE_DISEASE.getSNOMEDCTID(); break;
		case LUMINAL_IRREGULARITIES : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.LUMINAL_IRREGULARITIES.getSNOMEDCTID(); break;
		case MUSCLE_BRIDGE : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.MUSCLE_BRIDGE.getSNOMEDCTID(); break;
		case STENOTIC : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.STENOTIC.getSNOMEDCTID(); break;
		case ECTATIC : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.ECTATIC.getSNOMEDCTID(); break;
		case CALCIFIED : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.CALCIFIED.getSNOMEDCTID(); break;
		case THROMBUS : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.THROMBUS.getSNOMEDCTID(); break;
		case TORTUOUS : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.TORTUOUS.getSNOMEDCTID(); break;
		case STENTED : this.strSNOMEDCTID =EnumAnatomicSNOMEDMap.STENTED.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for Vessel Descriptors
	 * @param enumVesselDescriptors Boject of EnumCM_VesselDescriptors.
	 */
	public void setVesselDescriptors(EnumCM_VesselDescriptors enumVesselDescriptors)
	{
		this.strCodeMeaning = enumVesselDescriptors.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		setCodeValue(enumVesselDescriptors);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumVesselDescriptors);
	}
}
